; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;
; AutoPicConverter
;                               2005 by PMV
;
; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;
;   Kleines Tool um Bilddateien in ein anderes Format zu konvertieren.
;   Untersttzte Bildformate sind:
;                   - BMP
;                   - JPEG (mit Komprimierung)
;                   - PNG
;                   - TIFF (nur Laden)
;                   - TGA  (nur Laden)
;
; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;DisableDebugger

;Decoder und Encoder
UseJPEGImageDecoder()
UseJPEGImageEncoder()
UsePNGImageDecoder()
UsePNGImageEncoder()
UseTIFFImageDecoder()
UseTGAImageDecoder()
; -----------------------------

;Globale Gadgets des Hauptfensters
Global SorceFrame3D.l, DestiFrame3D.l                 ;groe Rahmen um die Auswahl der Bilder
Global SorcePathGadget.l, DestiPathGadget.l           ;Stringgadget fr die Eingabe der Pfade
Global SorceButtonGadget.l, DestiButtonGadget.l       ;Durchsuchen-Button zum Auswhlen der Pfade
Global SorceListGadget.l, DestiListGadget.l           ;Listgadgets mit den zu bearbeitenden Bildern
Global SorceTextGadget.l, DestiTextGadget.l           ;Text fr die Dateitypauswahl
Global SorceExtensionGadget.l, DestiExtensionGadget.l ;Auswahl der mglichen Dateitypen
Global AddGadget.l, DeleteGadget.l                    ;alle Bilder hinzufgen/ entfernen Button
Global SizeFrame3D.l                                  ;Bildgre ndern Rahmen
Global ChangeSizeGadget.l                             ;Checkbox um die Bildgrennderung zu (de)aktivieren
Global absoluteSizeGadget.l, relativeSizeGadget.l     ;Optionen fr die Resizefunktion
Global ResizeTextWidth.l, ResizeTextHeight.l          ;Text fr die Resizeeingabe
Global NewWidthGadget.l, NewHeightGadget.l            ;Eingabe der Resizefunktion
Global CompressFrame3D.l                              ;Rahmen frs Komprimieren
Global CompressGadget.l                               ;Schieberegler fr die Komprimierung
Global CompressText1.l,CompressText2.l,CompressText3.l;Text fr den Komprimierenregler
Global DirectoryGadget.l                              ;Checkbox um des Untersuchen von Unterordnern zu (de)aktivieren
Global StartGadget.l, QuitGadget.l                    ;Start- und Beendenbutton
Global ChangeNameFrame3D.l                            ;Rahmen fr die Namensnderung
Global ChangeNameOption1.l, ChangeNameOption2.l       ;Option fr das ndern des Dateinamens
Global ChangeNameOption3.l
Global ChangeNameInput1.l, ChangeNameInput2.l         ;Eingabefelder fr den Dateinamen
Global ChangeNameText.l                               ;Text um die Position der Nummerrierung zu verdeutlichen
; ------------------------------

;Threadvariablen
Global Thread.l                     ;0 bedeutet, kein Thread aktiv, ansonnsten die ThreadID
Global ThreadText$, ThreadState.l   ;Variablen um den Inhalt des WaitWindows zu manipulieren
Global ImageCount.l, ErrorCount.l   ;Counter fr die Threads
; ------------------------------

;Sonstige globale Variablen
Global WindowID.l                 ;ID des Hauptfensters      
Global SorcePath$, DestiPath$     ;Pfade zum Quell- und Zielverzeichnis
; ------------------------------

;Default Werte
#DefaultWidth = 500
#DefaultHeight = 400
#BorderSize = 10
#ProgrammTitle = "PMVs AutoPicConverter"
#ErrorFile = "AutoPicConverter_Error.txt"
#DefaultPathLength = 35    ;fr die Nicht-Windows-Prozedur
; -----------------------------

;soll Waitwindow Textbalken bekommen, damit man dem Fenster ansieht, das gearbeitet wird
#TextAnimation = #False      ; 0 oder 1
; -----------------------------

;Mindest Fenstergre
#MinWidth = 500
#MinHeight = 300
; -----------------------------

;Flags fr WaitWindow()
#WaitWindow_DynText =  %1
#WaitWindow_Progress = %10
; -----------------------------

;mgliche auswhlbare Endungen
Enumeration
  #Image_BMP
  #Image_JPEG
  #Image_PNG
  #Image_TIFF
  #Image_TGA
EndEnumeration

#ImageType = 4          ;Anzahl der mglichen Bildformate (-1)
#ExtensionPerType = 1   ;Anzahl der mglichen Dateiendungen pro Bildformat (-1)

Dim Extension.s(#ImageType, #ExtensionPerType) ;Dateinamenerweiterung der Bildformate
Extension(#Image_BMP,  0) = "bmp"
Extension(#Image_JPEG, 0) = "jpg" : Extension(#Image_JPEG, 1) = "jpeg"
Extension(#Image_PNG,  0) = "png"
Extension(#Image_TIFF, 0) = "tif" : Extension(#Image_TIFF, 1) = "tiff"
Extension(#Image_TGA,  0) = "tga"


Dim ImageType.s(#ImageType) ;Bezeichnung der Bildformate
ImageType(#Image_BMP) = "Windows Bitmap (*.bmp)"
ImageType(#Image_JPEG) = "JPEG (*.jpg, *.jpeg)"
ImageType(#Image_PNG) = "Portable Network Graphics (*.png)"
ImageType(#Image_TIFF) = "Tagged Image File-Format (*.tif, *.tiff)"
ImageType(#Image_TGA) = "Targa Image File (*.tga)"

Dim ImageSupport(#ImageType)     ;Bildformate werden untersttzt 
ImageSupport(#Image_BMP)  = %11  ;(%01 - Laden; %10 - Speichern; %11 - Beides)
ImageSupport(#Image_JPEG) = %11
ImageSupport(#Image_PNG)  = %11
ImageSupport(#Image_TIFF) = %01
ImageSupport(#Image_TGA)  = %01

Dim ImageTypePos(#ImageType, 1)  ;Speichert, welches Dateiformat an welcher Position es
                                 ;sich in der Combobox befindet
; ----------------------------

;========================================================================================================

;Gibt einen gekrzten Pfad zurck
CompilerIf #PB_Compiler_OS = #PB_OS_Windows
Procedure.s ShortPath(Path$, GadgetID)
  Protected Path$, *p, Lib.l
  Lib = OpenLibrary(#PB_Any,"shlwapi.dll") 
  If Lib 
    *p = IsFunction(Lib, "PathCompactPathA") 
    If *p 
      CallFunctionFast(*p, GetDC_(GadgetID(GadgetID)), Path$, GadgetWidth(GadgetID)) 
    EndIf
    CloseLibrary(Lib) 
  EndIf 
  ProcedureReturn Path$ 
EndProcedure
;Originalprozedur von FGK aus dem Deutschen PB-Forum
;http://forums.purebasic.com/german/viewtopic.php?t=4871&start=0&postdays=0&postorder=asc&highlight=path%2Apath

CompilerElse ;#PB_Compiler_OS = #PB_OS_Linux
Procedure.s ShortPath(Path$, GadgetID)
  Protected Len.l         ;maximale Lnge des Pfades
  Protected Result$       ;spteres Ergebnis
  Protected Num.l         ;Counter der bisheriegen Durchlufe
  Protected Pos.l         ;Position des letzten Verzeichnisses im Pfad
  Protected Pos2.l        ;Position des Verzeichnisses an wessen stelle die "..." angezeigt werden
  Protected Number.l      ;Anzahl der Unterordnern
  Result$ = Path$
  
  ;gewnschte Lnge ermitteln
  ;Len = GadgetWidth(GadgetID)
  Len = #DefaultPathLength
  ; ---------------
  
  ;Position des letzten Verzeichnisnamens ermitteln (mit dem vorheriegen Backslash)
  Number = CountString(Path$, "\")
  If Right(Path$, 1) <> "\"
    Number + 1
  EndIf
  Pos = FindString(Path$, StringField(Path$, Number, "\"), 1) - 2
  ; ---------------

  ;Dem Pfad so lange die mittleren Verzeichnisse lschen, bis die gewnschte Lnge
  ;eingehalten wird
  While Len(Result$) > Len And Left(Result$, 3) <> "..."
    Num + 1 ;Counter
    Pos2 = FindString(Path$, StringField(Path$, Number - Num, "\"), 1) - 1 ;zu lschendes Verzeichnis
    Result$ = Left(Path$, Pos2)+"..."+Right(Path$, Len(Path$) - Pos) ;Ergebnis
  Wend
  ; ---------------
  
  ;wenn ganz Links die "..." sind und die Lnge immer noch zu gro ist
  If Left(Result$,3) = "..." And Len(Result$) > Len
    Result$ = "..." + Mid(Result$, 4, Len - 3) ;Damit das ganze wirklich nur die vorgegebene Lnge hat
  EndIf
  ; --------------
  

  ProcedureReturn Result$ ;String zurck geben
EndProcedure
CompilerEndIf

; --------------------------------------------------------------------------------------

;passt die Gadgets des Hauptfensters einer neuen Gre an
Procedure ResizeMainWindow()
  Protected X.l, Y.l, Width.l, Height.l, n.l
  Protected WindowWidth.l, WindowHeight.l
  
  ;neue Gre speichern
  UseWindow(WindowID)
  WindowWidth = WindowWidth()
  WindowHeight = WindowHeight()
  ; --------------
  
  ;berprft, ob die aktuelle Fenstergre im soll ist
  If WindowWidth < #MinWidth
    ResizeWindow(#MinWidth, WindowHeight)
    ProcedureReturn
  ElseIf  WindowHeight < #MinHeight
    ResizeWindow(WindowWidth, #MinHeight)
    ProcedureReturn
  EndIf
  ; -------------
  
  Delay(50) ;wirkt etwas gegen das seltzame verschieben von einigen Gadgets
  
  ;groe Rahmen um die Auswahl der Bilder
  X = #BorderSize
  Y = 1
  Width = WindowWidth/2 - X * 2
  Height = WindowHeight - 185 
  ResizeGadget(SorceFrame3D, X, Y, Width, Height)
  ResizeGadget(DestiFrame3D, X + WindowWidth/2, Y, Width, Height)
  ; -------------
  
  ;StringGadget fr die Eingabe der Pfade
  X + 4
  Y + 18
  Width = WindowWidth/2 - X * 2 - 20
  Height = 20
  ResizeGadget(SorcePathGadget, X, Y, Width, Height)
  ResizeGadget(DestiPathGadget, X + WindowWidth/2, Y, Width, Height)
  ; --------------

  ;Durchsuchen-Button zum Auswhlen der Pfade
  X = WindowWidth/2 - 20 - X
  Y - 1
  Width = 20
  Height = 22
  ResizeGadget(SorceButtonGadget, X, Y, Width, Height)
  ResizeGadget(DestiButtonGadget, X + WindowWidth/2, Y, Width, Height)
  ; ---------------

  ;Listgadgets mit den zu bearbeitenden Bildern
  X = #BorderSize + 4
  Y + 23
  Width = WindowWidth/2 - X * 2
  Height = WindowHeight - 280
  ResizeGadget(SorceListGadget, X, Y, Width, Height)
  ResizeGadget(DestiListGadget, X + WindowWidth/2, Y, Width, Height)
  ; ---------------

  ;Text fr die Dateitypauswahl
  X + 0
  Y + Height + 4
  Width = 60
  Height = 20
  ResizeGadget(SorceTextGadget, X, Y, Width, Height)
  ResizeGadget(DestiTextGadget, X + WindowWidth/2, Y, Width, Height)
  ; ---------------
  
  ;Auswahl der mglichen Dateitypen
  X + Width
  Y - 2
  Width = WindowWidth/2 - X - #BorderSize - 4
  Height = 20
  ResizeGadget(SorceExtensionGadget, X, Y, Width, Height)
  ResizeGadget(DestiExtensionGadget, X + WindowWidth/2, Y, Width, Height)
  ; ---------------
  
  ;alle Bilder hinzufgen/ entfernen Button
  X = #BorderSize + 25
  Y + 25
  Width = WindowWidth/2 - X * 2
  Height = 23
  ResizeGadget(AddGadget, X, Y, Width, Height)
  ResizeGadget(DeleteGadget, X + WindowWidth/2, Y, Width, Height)
  ; ---------------
  
  ;Bildgre ndern Rahmen
  X = #BorderSize
  Y + 35
  Width = WindowWidth/2 - X * 2
  Height = 100
  ResizeGadget(SizeFrame3D, X, Y, Width, Height)
  ; ---------------
  
  ;Checkbox um die Bildgrennderung zu (de)aktivieren
  X + 15
  Y - 3
  Width = 99
  Height = 20
  ResizeGadget(ChangeSizeGadget, X, Y, Width, Height)
  ; ---------------
  
  ;Optionen fr die Resizefunktion
  X + 20
  Y + 22
  Width = 150
  Height = 20
  ResizeGadget(absoluteSizeGadget, X, Y, Width, Height)
  ResizeGadget(relativeSizeGadget, X, Y + 20, Width, Height)
  ; ---------------

  ;Text fr die Resizeeingabe
  X = #BorderSize + 9
  Y + 50
  Width = 60
  Height = 20
  ResizeGadget(ResizeTextWidth, X, Y, Width, Height)
  ResizeGadget(ResizeTextHeight, X + 110, Y, Width, Height)
  ; ---------------
  
  ;Eingabe der Resizefunktion
  X + Width
  Y - 2
  Width = 44
  Height = 20
  ResizeGadget(NewWidthGadget, X , Y, Width, Height)
  ResizeGadget(NewHeightGadget, X + 110, Y, Width, Height)
  ; ---------------
  
  ;Checkbox um des Untersuchen von Unterordnern zu (de)aktivieren
  X = WindowWidth/4 - 100
  Y + 35
  Width = 200
  Height = 20
  ResizeGadget(DirectoryGadget, X, Y, Width, Height)
  ; ----------------
  
  ;Start- und Beendenbutton
  X + 0
  Y + Height
  Width = 200
  Height = 25
  ResizeGadget(StartGadget, X, Y, Width, Height)
  ResizeGadget(QuitGadget, X, Y + Height, Width, Height)
  ; ----------------

  
  ;Rahmen frs Komprimieren
  X = #BorderSize
  Y = WindowHeight - 176 
  Width = WindowWidth/2  - X * 2
  Height = 60
  ResizeGadget(CompressFrame3D, X + WindowWidth/2, Y, Width, Height)
  ; ---------------
  
  ;Schieberegler fr die Komprimierung
  X + 8
  Y + 15
  Width - 20
  Height = 20
  ResizeGadget(CompressGadget, X + WindowWidth/2, Y, Width, Height)
  ; ----------------

  ;Text fr den Komprimierenregler
  ResizeGadget(CompressText1, X + WindowWidth/2, Y + Height, 30, 20)
  ResizeGadget(CompressText2, X + WindowWidth/2 + Width/2  - 12, Y + Height, 24, 20)
  ResizeGadget(CompressText3, X + WindowWidth/2 + Width-10 - 10, Y + Height, 26, 20)
  ; ----------------

  ;Rahmen fr die Dateinamen nderung
  X = #BorderSize
  Y + 45
  Width = WindowWidth/2 - X * 2
  Height = 105
  ResizeGadget(ChangeNameFrame3D, X + WindowWidth/2, Y, Width, Height)
  ; -----------------
  
  ;Option fr das ndern des Dateinamens
  X + 8
  Y + 15
  Width - 20
  Height = 20
  ResizeGadget(ChangeNameOption1, X + WindowWidth/2, Y, Width, Height)
  ResizeGadget(ChangeNameOption2, X + WindowWidth/2, Y + Height, Width, Height)
  ResizeGadget(ChangeNameOption3, X + WindowWidth/2, Y + Height * 2, Width, Height)
  ; ----------------
  
  ;Eingabefelder fr den Dateinamen
  X + 0
  Y + Height * 3
  Width / 2
  Height = 20
  If GadgetX(ChangeNameInput1) + GadgetWidth(ChangeNameInput1) < GadgetX(ChangeNameInput2)
    n = 7
  EndIf
  ResizeGadget(ChangeNameInput1, X + WindowWidth/2, Y, Width - n, Height)
  ResizeGadget(ChangeNameInput2, X + WindowWidth/2 + Width + n, Y, Width - n, Height)
  ; ----------------

  ;Text um die Position der Nummerrierung zu verdeutlichen
  X - 6 + Width
  Y + 2
  Width = 12
  Height = 20
  ResizeGadget(ChangeNameText, X + WindowWidth/2, Y, Width, Height)
  ; ----------------

EndProcedure

; ---------------------------------------------------------------------------------------

;Thread zum erstellen der neuen Bilddateien
Procedure MakeNewImages()
  Protected Count.l, tempImage.l, ImagePath$, Width.l, Height.l
  Protected ImageName$, ImageExtension$, Num.l, ErrorFile.l, Result.l
  
  Count = CountGadgetItems(DestiListGadget)-1
  
  ;Wenn die Gre der Bildes absolut verndert werden soll
  If GetGadgetState(absoluteSizeGadget)
    Width = Val(GetGadgetText(NewWidthGadget))
    Height = Val(GetGadgetText(NewHeightGadget))
  EndIf
  ; --------------------
  
  For Num = 0 To Count

    ImagePath$ = SorcePath$ + GetGadgetItemText(DestiListGadget, Num, 0)

    ;Bild laden
    tempImage = LoadImage(#PB_Any, ImagePath$)
    ; -------------------
    
    Result = #False
    If tempImage
      ;Wenn das Bild in der Gre vernderden soll
      If GetGadgetState(ChangeSizeGadget)
        If GetGadgetState(relativeSizeGadget)
          Width = ImageWidth() * Val(GetGadgetText(NewWidthGadget)) / 100
          Height = ImageHeight() * Val(GetGadgetText(NewHeightGadget)) / 100
        EndIf
        ResizeImage(tempImage, Width, Height)
      EndIf
    
      ;Dateiendung raussuchen
      ImageExtension$ = GetExtensionPart(ImagePath$)
      ; ---------------
      
      ;neuen Dateinamen ermitteln
      If GetGadgetState(ChangeNameOption3) ;Dateiname soll komplet neu sein (durchnummerieren)
        ImageName$ = GetGadgetText(ChangeNameInput1) + Str(Num+1) + GetGadgetText(ChangeNameInput2)
      Else
        ;alten Dateinamen ermitteln
        ImageName$ = GetFilePart(ImagePath$)
        ImageName$ = Left(ImageName$, Len(ImageName$) - 1 - Len(ImageExtension$))
        If GetGadgetState(ChangeNameOption2) ;Dateiname soll ergnzet werden
          ImageName$ = GetGadgetText(ChangeNameInput1) + ImageName$ + GetGadgetText(ChangeNameInput2)
        EndIf
      EndIf
      
      Select GetGadgetState(DestiExtensionGadget)
        Case ImageTypePos(#Image_BMP, 1) ; zu BMP
          Result = SaveImage(tempImage, DestiPath$ + ImageName$ + "." + Extension(#Image_BMP, 0))

        Case ImageTypePos(#Image_JPEG, 1)  ; zu JPG (komprimieren)
          Result = SaveImage(tempImage, DestiPath$ + ImageName$ + "." + Extension(#Image_JPEG, 0), #PB_ImagePlugin_JPEG, GetGadgetState(CompressGadget))

        Case ImageTypePos(#Image_PNG, 1)  ; zu PNG
          Result = SaveImage(tempImage, DestiPath$ + ImageName$ + "." + Extension(#Image_PNG, 0), #PB_ImagePlugin_PNG)

        Default ; keine Dateiendung nderung
          If LCase(ImageExtension$) = Extension(#Image_BMP, 0)
             Result = SaveImage(tempImage, DestiPath$ + ImageName$ + "." + ImageExtension$)
          ElseIf LCase(ImageExtension$) = Extension(#Image_JPEG, 0)
             Result = SaveImage(tempImage, DestiPath$ + ImageName$ + "." + ImageExtension$, #PB_ImagePlugin_JPEG, GetGadgetState(CompressGadget))
          ElseIf LCase(ImageExtension$) = Extension(#Image_PNG, 0)
             Result = SaveImage(tempImage, DestiPath$ + ImageName$ + "." + ImageExtension$, #PB_ImagePlugin_PNG)
          EndIf
      EndSelect
      
      FreeImage(tempImage)
    EndIf
    If Result = #False
      ErrorCount + 1
      If ErrorFile = #False
        ErrorFile = CreateFile(#PB_Any, #ErrorFile)
        If ErrorFile
          WriteStringN("Fehlerprotokoll des " + #ProgrammTitle + " vom " + FormatDate("%dd.%mm.%yyyy erstellt um %hh:%ii:%ss", Date()) + " Uhr.")
          WriteStringN("Folgende Bilddateien konnten nicht umgewandelt werden:")
          WriteStringN("")
          WriteStringN(ImagePath$)
        EndIf
      Else
        WriteStringN(ImagePath$)
      EndIf
    EndIf

    ThreadState = (Num+1) * 1000 / (Count+1) 
   
    If Thread = #False
      ErrorCount = -1
      Break
    EndIf
  Next
  
  If ErrorFile
    CloseFile(ErrorFile)
  EndIf
  Thread = #False
EndProcedure

; -----------------------------------------------------------------------------------------

;schreibt die Bilddateien vom Zielverzeichnis (und Unterverzeichnisse) in die Zielliste
Procedure UpdateSorceList(Path$, Extension)
  Protected Directory.l, Extension.l
  
  ;dynamischen Text aktualisieren
  ThreadText$ = "Verzeichnis: " + SorcePath$ + Path$
  ; ---------------
  
  ;Verzeichnis auswhlen
  Directory = ExamineDirectory(#PB_Any, SorcePath$ + Path$, "")
  ; ---------------
  
  If Directory
    Repeat
      Select NextDirectoryEntry()
        Case 0 ; kein weiterer Eintrag
            ProcedureReturn

        Case 1 ; Datei
          If Extension > #ImageType ;alle mglichen Endungen durchgehen
            For Num = 0 To #ImageType
              For Num2 = 0 To #ExtensionPerType
                If Extension(Num, Num2) And LCase(GetExtensionPart(DirectoryEntryName())) = Extension(Num, Num2)
                  AddGadgetItem(SorceListgadget, ImageCount, Path$ + DirectoryEntryName())
                  ImageCount + 1
                EndIf
              Next
            Next
          Else
            For Num2 = 0 To #ExtensionPerType
              If Extension(Extension, Num2) And LCase(GetExtensionPart(DirectoryEntryName())) = Extension(Extension, Num2)
                AddGadgetItem(SorceListgadget, ImageCount, Path$ + DirectoryEntryName())
                ImageCount + 1
              EndIf
            Next
          EndIf
        Case 2 ; Verzeichnis
          If DirectoryEntryName() <> "." And DirectoryEntryName() <> ".." And GetGadgetState(DirectoryGadget)
            UpdateSorceList(Path$ + DirectoryEntryName() + "\", Extension)
            UseDirectory(Directory)
            AktiveText$ = SorcePath$ + Path$
          EndIf
      EndSelect
    Until Thread = #False
  EndIf
EndProcedure

; ----------------------------------------------------------------------------------------

;Thread, welcher die Quellliste im Hintergrund aktualisiert und die Ordner durchsucht
Procedure UpdateThread(GadgetState)
  Protected Num.l
  ImageCount = 0
  UpdateSorceList("", GetGadgetState(SorceExtensionGadget))
  MessageRequester(#ProgrammTitle, "Es wurden insgesamt " + Str(ImageCount) + " Bilddateien gefunden.", #MB_ICONINFORMATION)
  Thread = #False
EndProcedure

; ------------------------------------------------------------------------------------------

;Wartet, das der aktuelle Thread beendet wird und zeigt so lange ein Fenster mit einem Abbrechenbutton an
Procedure WaitWindow(Text$, Flags)
  Protected Window.l, Timer.l, Symbole$, Button.l, hWnd.l
  Protected Gadget1.l, Gadget2.l, Gadget3.l, Gadget4.l
  Protected TextGadget.l, ProgressGadget.l, StaticText.l
  
  ;Fenster erstellen
  Window = OpenWindow(#PB_Any, 0, 0, 300, 60, #PB_Window_ScreenCentered, #Programmtitle + " - Bitte Warten")
  hWnd = WindowID(Window)
  ; -------------
  
  ;Gadgets erstellen
  CreateGadgetList(WindowID())
    ;wird bentigt, damit die Textgadgets nicht flackern
    tempGadget = TextGadget(#PB_Any, 1, 1, 1, 1, "")
    ; ------------
      
    ;starrer Text mit animierten seiten
    StaticText = TextGadget(#PB_Any, 20, 7, 150, 17, Text$)
    CompilerIf #TextAnimation
      Gadget1.l = TextGadget(#PB_Any, 5, 7, 10, 17, "\")
      Gadget2.l = TextGadget(#PB_Any, 10, 7, 10, 17, "\")
      Gadget3.l = TextGadget(#PB_Any, 185, 7, 10, 17, "\")
      Gadget4.l = TextGadget(#PB_Any, 190, 7, 10, 17, "\")
    CompilerEndIf
    ; ---------------

    ;Abbrechenbutton
    Button = ButtonGadget(#PB_Any, 200, 3, 100, 20, "Abbrechen")
    ; ---------------

    If Flags & #WaitWindow_DynText
      ;Gadget fr den dynamischen Text
      TextGadget = TextGadget(#PB_Any, 5, 25, 290, 30,"")
      Flags = #WaitWindow_DynText
    ElseIf Flags & #WaitWindow_Progress
      ;Gadget fr die vortschrittsanzeige
      ProgressGadget = ProgressBarGadget(#PB_Any, 5, 24, 290, 30, 0, 1000)
      Flags = #WaitWindow_Progress
    EndIf
    ; ---------------
  ; --------------------------
  
  
  ;Procedureschleife
  While Thread
  
    ;Eventabfrage
    Select WindowEvent() 
      Case #PB_Event_Gadget
        If EventGadgetID() = Button
          ;es wurde auf den Abbrechenbutton gedrckt
          If MessageRequester(#ProgrammTitle, "Soll wirklich abgebrochen werden?", #MB_YESNO|#MB_ICONWARNING|#MB_DEFBUTTON2) = #IDYES
            ;Benutzter hat die Sicherheitswarnung besttigt, Suche beenden
            Thread = #False
          EndIf
        EndIf
      Default 
        Delay(10)
    EndSelect
    ; ------------
    
    ;Zeitabfrage
    If Timer + 200 < ElapsedMilliseconds() 
      Timer = ElapsedMilliseconds()
      SetGadgetText(tempGadget, " ") ;wird bentigt, damit die Textgadgets nicht flackern
      
      ;Animieren
      CompilerIf #TextAnimation
        Num + 1
        If Num > 3 : Num = 0 : EndIf
        Select Num
          Case 0
            Symbole$ = "\"
          Case 1
            Symbole$ = "|"
          Case 2
            Symbole$ = "/"
          Case 3
            Symbole$ = "|"
        EndSelect
        SetGadgetText(Gadget1, Symbole$)
        SetGadgetText(Gadget2, Symbole$)
        SetGadgetText(Gadget3, Symbole$)
        SetGadgetText(Gadget4, Symbole$)
      CompilerEndIf
      ; --------

      Select Flags
        Case #WaitWindow_DynText
          ;dynamischen Text aktualisieren
          SetGadgetText(TextGadget, ThreadText$)
        Case #WaitWindow_Progress
          ;Progressbar aktualisieren
          SetGadgetText(StaticText, Text$ + " (" + StrF(ThreadState / 10, 1) + "%)")
          SetGadgetState(ProgressGadget, ThreadState)
      EndSelect
    EndIf
    ; -------------
  Wend
  
  ;Anzeigen resetten
  ThreadState = #False
  ThreadText$ = ""
  ; ---------------
  
  ;da Thread beenden (wird), Fenster schlieen
  CloseWindow(Window)
EndProcedure

; -----------------------------------------------------------------------------------------

;Zeigt eine Nachrichtenbox an mit der Frage, ob das Quellverzeichnis neu durchsucht werden soll
Procedure UpdateMessage()
  MessageBeep_(#MB_OK)
  If MessageRequester(#ProgrammTitle, "Wollen Sie nach dieser nderung eine neue Suche durchfhren?", #MB_YESNO|#MB_ICONQUESTION) = #IDYES
    HideWindow(WindowID, #True)
             
    SetGadgetText(SorcePathGadget, SorcePath$)
    ;alte Eintrge lschen
    ClearGadgetItemList(SorceListGadget)
    ; ----------------
              
    ;Startet die Suche und die Anzeige
    Thread = CreateThread(@UpdateThread(), GetGadgetState(SorceExtensionGadget))
    WaitWindow("Suche Bilddateien...", #WaitWindow_DynText)
    HideWindow(WindowID, #False)
    ; ----------------
              
    ;Aktivieren oder Deaktivieren des 'alles hinzufgen' Gadgets
    If CountGadgetItems(SorceListGadget)
      DisableGadget(AddGadget, #False)
    Else
      DisableGadget(AddGadget, #True)
    EndIf
    ; ----------------
  EndIf   
EndProcedure

;============================================================================================================

;Pfat zu einem Ordner auswhlen
SorcePath$ = PathRequester("Bitte einen Ortner auswhlen, in welchem sich die zu bearbeitenden Bilder befinden:", "")
DestiPath$ = SorcePath$
; -----------------------------

;Fenster ffnen
WindowID = OpenWindow(#PB_Any, 0, 0, #DefaultWidth, #DefaultHeight, #PB_Window_ScreenCentered | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_Invisible | #PB_Window_SizeGadget, #ProgrammTitle)
; -----------------------------

;-Gadgets erstellen
CreateGadgetList(WindowID())
  ;groe Rahmen um die Auswahl der Bilder
  SorceFrame3D = Frame3DGadget(#PB_Any, 1, 1, 1, 1, "verfgbare Bilder") ;"Sorce"
  DestiFrame3D = Frame3DGadget(#PB_Any, 1, 1, 1, 1, "ausgewhlte Bilder" ) ;"Destionation"

  ;Stringgadget fr die Eingabe der Pfade
  SorcePathGadget = StringGadget(#PB_Any, 1, 1, 1, 1, "", #PB_String_ReadOnly)
  DestiPathGadget = StringGadget(#PB_Any, 1, 1, 1, 1, "", #PB_String_ReadOnly)
  
  ;Durchsuchen-Button zum Auswhlen der Pfade
  SorceButtonGadget = ButtonGadget(#PB_Any, 1, 1, 1, 1, "...")
  DestiButtonGadget = ButtonGadget(#PB_Any, 1, 1, 1, 1, "...")

  ;Listgadgets mit den zu bearbeitenden Bildern
  SorceListGadget = ListViewGadget(#PB_Any, 1, 1, 1, 1)
  DestiListGadget = ListViewGadget(#PB_Any, 1, 1, 1, 1)

  ;Text fr die Dateitypauswahl
  SorceTextGadget = TextGadget(#PB_Any, 1, 1, 1, 1, "Dateityp:")
  DestiTextGadget = TextGadget(#PB_Any, 1, 1, 1, 1, "Dateityp:")

  ;Auswahl der mglichen Dateitypen
  SorceExtensionGadget = ComboBoxGadget(#PB_Any, 1, 1, 1, 1)
  DestiExtensionGadget = ComboBoxGadget(#PB_Any, 1, 1, 1, 1)
  
  ;alle Bilder hinzufgen/ entfernen Button
  AddGadget = ButtonGadget(#PB_Any, 1, 1, 1, 1, "alle Bilder hinzufgen")
  DeleteGadget = ButtonGadget(#PB_Any, 1, 1, 1, 1, "alle Bilder entfernen")
  
  ;Bildgre ndern Rahmen
  SizeFrame3D = Frame3DGadget(#PB_Any, 1, 1, 1, 1, "")

  ;Checkbox um die Bildgrennderung zu (de)aktivieren
  ChangeSizeGadget = CheckBoxGadget(#PB_Any, 1, 1, 1, 1, "Bildgre ndern")

  ;Optionen fr die Resizefunktion
  absoluteSizeGadget = OptionGadget(#PB_Any, 1, 1, 1, 1, "absolut (angaben in Pixel)")
  relativeSizeGadget = OptionGadget(#PB_Any, 1, 1, 1, 1, "relativ (angaben in Prozent)")

  ;Text fr die Resizeeingabe
  ResizeTextWidth = TextGadget(#PB_Any, 1, 1, 1, 1, "neue Breite:")
  ResizeTextHeight = TextGadget(#PB_Any, 1, 1, 1, 1, "neue Hhe:")

  ;Eingabe der Resizefunktion
  NewWidthGadget = StringGadget(#PB_Any, 1, 1, 1, 1, "", #PB_String_Numeric)
  NewHeightGadget = StringGadget(#PB_Any, 1, 1, 1, 1, "", #PB_String_Numeric)

  ;Rahmen frs Komprimieren
  CompressFrame3D = Frame3DGadget(#PB_Any, 1, 1, 1, 1, "Komprimieren von JPEG Bildern")
  
  ;Schieberegler fr die Komprimierung
  CompressGadget = TrackBarGadget(#PB_Any, 1, 1, 1, 1, 0, 10, #PB_TrackBar_Ticks)

  ;Text fr das Komprimierenregler
  CompressText1 = TextGadget(#PB_Any, 1, 1, 1, 1, "stark")
  CompressText2 = TextGadget(#PB_Any, 1, 1, 1, 1, "mittel")
  CompressText3 = TextGadget(#PB_Any, 1, 1, 1, 1, "leicht")
  
  ;Checkbox um des Untersuchen von Unterordnern zu (de)aktivieren
  DirectoryGadget = CheckBoxGadget(#PB_Any, 1, 1, 1, 1, "Bilder aus Unterordner verwenden")
  
  ;Start- und Beendenbutton
  StartGadget = ButtonGadget(#PB_Any, 1, 1, 1, 1, "Start...")
  QuitGadget = ButtonGadget(#PB_Any, 1, 1, 1, 1, "Beenden")

  ;Rahmen fr die Dateinamen nderung
  ChangeNameFrame3D = Frame3DGadget(#PB_Any, 1, 1, 1, 1, "Dateiname anpassen")
    
  ;Option fr das ndern des Dateinamens
  ChangeNameOption1 = OptionGadget(#PB_Any, 1, 1, 1, 1, "Dateinamen nicht ndern")
  ChangeNameOption2 = OptionGadget(#PB_Any, 1, 1, 1, 1, "Eingabe an Dateinamen anhngen")
  ChangeNameOption3 = OptionGadget(#PB_Any, 1, 1, 1, 1, "neuer Dateiname (+ Nummerrierung [n])")
  
  ;Eingabefelder fr den Dateinamen
  ChangeNameInput1 = StringGadget(#PB_Any, 1, 1, 1, 1, "")
  ChangeNameInput2 = StringGadget(#PB_Any, 1, 1, 1, 1, "")
  
  ;Text um die Position der Nummerrierung zu verdeutlichen
  ChangeNameText = TextGadget(#PB_Any, 1, 1, 1, 1, "[n]")
  
; -----------------------------
  
;Gadgets an die Fenstergre anpassen
ResizeMainWindow()
; ----------------------------- 

;Mgliche Dateiformate frs Laden
Counter = 0
For Num = 0 To #ImageType
  If ImageSupport(Num) & %01
    AddGadgetItem(SorceExtensionGadget, Counter, ImageType(Num))
    ImageTypePos(Num, 0) = Counter
    Counter + 1
    For Num2 = 0 To #ExtensionPerType
      If Extension(Num, Num2)
        AllExtension$ + "*." + Extension(Num, Num2) + ", "
      EndIf
    Next
  EndIf
Next
AddGadgetItem(SorceExtensionGadget, -1, "Alle (" + Left(AllExtension$, Len(AllExtension$)-2) + ")")
SetGadgetState(SorceExtensionGadget, Counter)
; -----------------------------

AllExtension$ = ""

;Mgliche Dateiformate frs Speichern
Counter = 0
For Num = 0 To #ImageType
  If ImageSupport(Num) & %10
    ImageTypePos(Num, 1) = Counter
    AddGadgetItem(DestiExtensionGadget, Counter, ImageType(Num))
    Counter + 1
  EndIf
Next
AddGadgetItem(DestiExtensionGadget, -1, "Bildformat nicht ndern (JPEG-Komprimierung aktiv)")
SetGadgetState(DestiExtensionGadget, Counter)
; ------------------------------

;Pfade in den vorgegebenen Stringgadgets ausgeben
SetGadgetText(SorcePathGadget, ShortPath(SorcePath$, SorcePathGadget))
SetGadgetText(DestiPathGadget, ShortPath(DestiPath$, DestiPathGadget))
; -----------------------------

;mgliche Resizegren angeben
SetGadgetText(NewWidthGadget, "1")
SetGadgetText(NewHeightGadget, "1")
; -----------------------------

;Option auswhlen
SetGadgetState(absoluteSizeGadget, #True)
SetGadgetState(ChangeNameOption2, #True)
; -----------------------------

;Defaulttext angeben
SetGadgetText(ChangeNameInput2, "(New)")
; -----------------------------

;Gadgets verstecken
HideGadget(ChangeNameText, #True)
; -----------------------------

;Trackbar verschieben
SetGadgetState(CompressGadget, 7)
; -----------------------------

;Unterordner auch durchsuchen
SetGadgetState(DirectoryGadget, #True)
; -----------------------------

;Gadgets deaktivieren
DisableGadget(absoluteSizeGadget, #True)
DisableGadget(relativeSizeGadget, #True)
DisableGadget(NewWidthGadget, #True)
DisableGadget(NewHeightGadget, #True)

DisableGadget(StartGadget, #True)
; -----------------------------

;-ToolTips fr die Gadgets
GadgetToolTip(SorcePathGadget, SorcePath$)
GadgetToolTip(DestiPathGadget, DestiPath$)

GadgetToolTip(SorceButtonGadget, "neues Quellverzeichnis auswhlen...")
GadgetToolTip(DestiButtonGadget, "neues Zielverzeichnis auswhlen...")

GadgetToolTip(SorceListGadget, "Doppelklick auf eine Bilddatei um diese der Liste hinzuzufgen")
GadgetToolTip(DestiListGadget, "Doppelklick auf eine Bilddatei um diese aus der Liste zu entfernen")

GadgetToolTip(SorceExtensionGadget, "Dateityp fr das Quellverzeichnis ndern")
GadgetToolTip(DestiExtensionGadget, "Format auswhlen, in das die Bilder umgewandelt werden sollen")

GadgetToolTip(AddGadget, "alle Bilder des Quellverzeichnis auswhlen")
GadgetToolTip(DeleteGadget, "alle Bilder aus der Zielliste entfernen")

GadgetToolTip(CompressGadget, "starke Komprimierung bedeutete schlechte Qualitt, leichte Komprimierung bedeutet gute Qualitt")

GadgetToolTip(StartGadget, "Bildgre ndern oder/ und umwandeln des Bildformates beginnen")
GadgetToolTip(QuitGadget, "Programm beenden")
; -----------------------------


;Quellliste erstellen
If SorcePath$
  Thread = CreateThread(@UpdateThread(), GetGadgetState(SorceExtensionGadget))
  WaitWindow("Suche Bilddateien...", #WaitWindow_DynText)
EndIf
; -----------------------------


;Hauptfenster anzeigen
HideWindow(WindowID, #False)
; -----------------------------

;-Hauptschleife  
Repeat
  Event = WaitWindowEvent()
  Select Event
    Case #PB_Event_SizeWindow ;ein Fenster wird in der Gre verndert
      If EventWindowID() = WindowID
        ResizeMainWindow()
      EndIf
    Case #PB_Event_Gadget
      Select EventGadgetID()
        Case SorceButtonGadget ;Quellverzeichnis wechseln und Liste aktualisieren
          Path$ = PathRequester("Bitte einen Ortner auswhlen:", SorcePath$)
          If Path$ ;neues Verzeichnis
            SorcePath$ = Path$
            HideWindow(WindowID, #True)
            ;Pfatanzeige fr den Benutzter
            SetGadgetText(SorcePathGadget, ShortPath(SorcePath$, SorcePathGadget))
            GadgetToolTip(SorcePathGadget, SorcePath$)
            ; ----------------
            
            ;alte Eintrge lschen
            ClearGadgetItemList(SorceListGadget)
            ; ----------------
            
            ;Startet die Suche und die Anzeige
            Thread = CreateThread(@UpdateThread(), GetGadgetState(SorceExtensionGadget))
            WaitWindow("Suche Bilddateien...", #WaitWindow_DynText)
            HideWindow(WindowID, #False)
            ; ----------------
            
            ;Aktivieren oder Deaktivieren des 'alles hinzufgen' Gadgets
            If CountGadgetItems(SorceListGadget)
              DisableGadget(AddGadget, #False)
            Else
              DisableGadget(AddGadget, #True)
            EndIf
            ; ----------------
          EndIf
        
        
        Case DestiButtonGadget ;Zielverzeichnis wechseln
          Path$ = PathRequester("Bitte einen Ortner auswhlen:", DestiPath$)
          If Path$ ; neues Verzeichnis ausgewhlt
            DestiPath$ = Path$
            SetGadgetText(DestiPathGadget, ShortPath(DestiPath$, DestiPathGadget))
            GadgetToolTip(DestiPathGadget, DestiPath$)
          EndIf
                
        Case SorceListGadget ;Quellliste
          ;Doppelklick auf einen Eintrag der Quellliste
          If EventType() = #PB_EventType_LeftDoubleClick
            ;durchluft die Zielliste auf der Suche nach dem neu einzutragendem Item
            Count = CountGadgetItems(DestiListGadget)-1
            NewItem$ = GetGadgetText(SorceListGadget)
            For Num = 0 To Count
              If GetGadgetItemText(DestiListGadget, Num, 0) = NewItem$ ;Eintrag bereits vorhanden
                Break
              EndIf
            Next
            If Num -1 = Count ;Eintrag noch nicht vorhanden
              AddGadgetItem(DestiListGadget, -1, NewItem$)
            EndIf
          EndIf
      
        Case DestiListGadget ; Zielliste
          ;Doppelklick auf einen Eintrag der Quelliste
          If EventType() = #PB_EventType_LeftDoubleClick
            ;bei Doppelklick Eintrag wieder entfernen
            RemoveGadgetItem(DestiListGadget, GetGadgetState(DestiListGadget))
          EndIf
         
        Case AddGadget ; alle Eintrge hinzufgen
          Count = CountGadgetItems(SorceListGadget)-1
          If Count <> CountGadgetItems(DestiListGadget)-1
            ClearGadgetItemList(DestiListGadget) ;alte Liste lschen
            ;alle Eintrge bernehmen
            For Num = 0 To Count
              AddGadgetItem(DestiListGadget, -1, GetGadgetItemText(SorceListGadget, Num, 0))
            Next
           
          EndIf
       
        Case DeleteGadget ; alle Eintrge lschen
          ClearGadgetItemList(DestiListGadget)
         
        Case DestiExtensionGadget ;Dateityp fr das Zielverzeichnis wurde gendert
          If GetGadgetState(DestiExtensionGadget) = ImageTypePos(#Image_JPEG, 1) Or GetGadgetState(DestiExtensionGadget) = CountGadgetItems(DestiExtensionGadget)-1
            ;wenn JPEG, Komprimierung whlen lassen
            DisableGadget(CompressGadget, #False)
          Else
            ;sonnst Kompirimerungseinstellungen deaktivieren
            DisableGadget(CompressGadget, #True)
          EndIf  
          
        Case DirectoryGadget ;Checkbox zum einstellen, ob Unterordner mit durchsucht werden sollen oder nicht
          UpdateMessage() ;Anfrage, ob nach der nderung neu gesucht werden soll
      
        Case ChangeSizeGadget ;Bilder auch in der Gre verndern?
          If GetGadgetState(ChangeSizeGadget)
            DisableGadget(absoluteSizeGadget, #False)
            DisableGadget(relativeSizeGadget, #False)
            DisableGadget(NewWidthGadget, #False)
            DisableGadget(NewHeightGadget, #False)
          Else
            DisableGadget(absoluteSizeGadget, #True)
            DisableGadget(relativeSizeGadget, #True)
            DisableGadget(NewWidthGadget, #True)
            DisableGadget(NewHeightGadget, #True)
          EndIf

        Case ChangeNameOption1 ;Dateinamen nicht ndern
          If GetGadgetState(ChangeNameOption1)
            DisableGadget(ChangeNameInput1, #True)
            DisableGadget(ChangeNameInput2, #True)
          EndIf
        
        Case ChangeNameOption2 ;Dateinamen ergnzen
          If GetGadgetState(ChangeNameOption2) 
            DisableGadget(ChangeNameInput1, #False)
            DisableGadget(ChangeNameInput2, #False) 
            ;Tooltip ndern und eventuell die Stringadgets wieder vergrern
            GadgetToolTip(ChangeNameInput1, "Text wird am Anfang des Dateinamens hinzugefgt")
            GadgetToolTip(ChangeNameInput2, "Text wird am Ende des Dateinamens hinzugefgt")
            If GadgetX(ChangeNameInput1) + GadgetWidth(ChangeNameInput1) < GadgetX(ChangeNameInput2)
              ResizeGadget(ChangeNameInput1, -1, -1, GadgetWidth(ChangeNameInput1) + 7, -1)
              ResizeGadget(ChangeNameInput2, GadgetX(ChangeNameInput2) - 7, -1, GadgetWidth(ChangeNameInput2) + 7, -1)
            EndIf
            HideGadget(ChangeNameText, #True) ;den "[n]"-Text verstecken
          EndIf
        Case ChangeNameOption3 ;neuer Dateinamen
          If GetGadgetState(ChangeNameOption3)
            DisableGadget(ChangeNameInput1, #False)
            DisableGadget(ChangeNameInput2, #False)
            ;Tooltip ndern und eventuell die Stringadgets wieder verkleinern
            GadgetToolTip(ChangeNameInput1, "Text wird vor der Nummerrierung hinzugefgt")
            GadgetToolTip(ChangeNameInput2, "Text wird hinter der Nummerrierung hinzugefgt")
            If GadgetX(ChangeNameInput1) + GadgetWidth(ChangeNameInput1) >= GadgetX(ChangeNameInput2)
              ResizeGadget(ChangeNameInput1, -1, -1, GadgetWidth(ChangeNameInput1) - 7, -1)
              ResizeGadget(ChangeNameInput2, GadgetX(ChangeNameInput2) + 7, -1, GadgetWidth(ChangeNameInput2) - 7, -1)
            EndIf
            HideGadget(ChangeNameText, #False) ;den "[n]"-Text anzeigen
          EndIf

        Case StartGadget ; Einstellungen durchfhren
          ;Abbruchvariable resetten
          Abbruch = #False
          
          ;wenn das Quellverzeichnis gleich dem Zielverzeichnis ist, und
          ;der Dateiname unverndert bleiben soll oder keine nderung
          ;angegeben wurde, Warnung einblenden
          If SorcePath$ = DestiPath$ And (GetGadgetState(ChangeNameOption1) Or (GetGadgetState(ChangeNameOption2) And GetGadgetText(ChangeNameInput1) = "" And GetGadgetText(ChangeNameInput2) = ""))
            If MessageRequester(#ProgrammTitle, "Mit den aktuellen Einstellungen knnte es passieren, das Quelldateien berschrieben" + Chr(13) + Chr(10) + "werden! Wollen Sie wirklich weiter machen?", #MB_ICONWARNING | #MB_DEFBUTTON2 | #MB_YESNO) = #IDNO
              Abbruch = #True
            EndIf
          EndIf
          ; -------------------
          
          If Abbruch = #False
            ;Counter resetten
            ErrorCount = #False
            ; -------------
            
            HideWindow(WindowID, #True)
            ;Thread starten und warten
            Thread = CreateThread(@MakeNewImages(), 0)
            Thread_ = Thread
            WaitWindow("Bilder werden erstellt...", #WaitWindow_Progress)
            WaitThread(Thread_)
            ; -------------

            ;Konnten alle Bilddateien erfolgreich erstellt werden?            
            If ErrorCount = #False ;Ja
              MessageRequester(#ProgrammTitle, "Erstellen der neuen Bilddateien erfolgreich", #MB_ICONINFORMATION)
            ElseIf ErrorCount = -1 ;Nein, aber der Anwender hat abgebrochen
              MessageRequester(#ProgrammTitle + " - Abbruch", "Erstellen der Bilddateien abgebrochen!", #MB_ICONERROR)
            Else ;Nein, Fehler traten auf
              MessageRequester(#ProgrammTitle + " - Fehler", "Beim erstellen der Bilddateien konnten " + Str(ErrorCount) + " von " + Str(CountGadgetItems(DestiListGadget)) + " Bilddatein nicht erstellt werden!", #MB_ICONERROR)
              RunProgram(#ErrorFile, "", "", 1)
            EndIf
            ; -------------
            HideWindow(WindowID, #False)
          EndIf


        Case QuitGadget ; Programm soll beendet werden
          MessageBeep_(#MB_OK)
          If MessageRequester(#ProgrammTitle, "Programm wirklich beenden?", #MB_YESNO|#MB_ICONQUESTION|#MB_DEFBUTTON2) = #IDYES
            End
          EndIf
            
        
      EndSelect
      
      ;Untersuchen, ob es Eintrge zum bearbeiten gibt
      If DestiPath$ And (GetGadgetState(DestiExtensionGadget) < CountGadgetItems(DestiExtensionGadget)-1 Or GetGadgetState(ChangeSizeGadget)) And CountGadgetItems(DestiListGadget)
        ;wenn ja, StartButton aktivieren
        DisableGadget(StartGadget, #False)
      Else
        ;sonnst deaktivieren
        DisableGadget(StartGadget, #True)
      EndIf
      ; -----------------------
      
    Case #PB_Event_CloseWindow ; Programm soll beendet werden
      MessageBeep_(#MB_OK)
      If MessageRequester(#ProgrammTitle, "Programm wirklich beenden?", #MB_YESNO|#MB_ICONQUESTION|#MB_DEFBUTTON2) = #IDYES
        End
      EndIf
  EndSelect
ForEver 
; IDE Options = PureBasic v3.94 (Windows - x86)
; CursorPosition = 133
; FirstLine = 55
; Folding = --
; EnableXP
; Executable = AutoPicConverter.exe
; IncludeVersionInfo
; VersionField0 = 1,0,1,0
; VersionField2 = von PMV
; VersionField6 = wandelt mehrere Bilder gleichzeitig in ein anders Format oder/ und ndert die Gre